org.jboss.netty.channel.socket

## Interface SocketChannelConfig

All Superinterfaces:
  ChannelConfig

All Known Subinterfaces:
  NioSocketChannelConfig

All Known Implementing Classes:
  DefaultSocketChannelConfig, HttpTunnelingSocketChannelConfig

    public interface SocketChannelConfig
    extends ChannelConfig

A `ChannelConfig` for a `SocketChannel`.

### Available options

In addition to the options provided by `ChannelConfig`, `SocketChannelConfig` allows the following options in the option map:

Name | Associated setter method
--- | ---
`"keepAlive"` | `setKeepAlive(boolean)`
`"reuseAddress"` | `setReuseAddress(boolean)`
`"soLinger"` | `setSoLinger(int)`
`"tcpNoDelay"` | `setTcpNoDelay(boolean)`
`"receiveBufferSize"` | `setReceiveBufferSize(int)`
`"sendBufferSize"` | `setSendBufferSize(int)`
`"trafficClass"` | `setTrafficClass(int)`

### Method Summary

Methods
`int` `getReceiveBufferSize()` Gets the `StandardSocketOptions.SO_RCVBUF` option.
`int` `getSendBufferSize()` Gets the `StandardSocketOptions.SO_SNDBUF` option.
`int` `getSoLinger()` Gets the `StandardSocketOptions.SO_LINGER` option.
`int` `getTrafficClass()` Gets the `StandardSocketOptions.IP_TOS` option.
`boolean` `isKeepAlive()` Gets the `StandardSocketOptions.SO_KEEPALIVE` option.
`boolean` `isReuseAddress()` Gets the `StandardSocketOptions.SO_REUSEADDR` option.
`boolean` `isTcpNoDelay()` Gets the `StandardSocketOptions.TCP_NODELAY` option.
`void` `setKeepAlive(boolean keepAlive)` Sets the `StandardSocketOptions.SO_KEEPALIVE` option.
`void` `setPerformancePreferences(int connectionTime, int latency, int bandwidth)` Sets the performance preferences as specified in `Socket.setPerformancePreferences(int, int, int)`.
`void` `setReceiveBufferSize(int receiveBufferSize)` Sets the `StandardSocketOptions.SO_RCVBUF` option.
`void` `setReuseAddress(boolean reuseAddress)` Sets the `StandardSocketOptions.SO_REUSEADDR` option.
`void` `setSendBufferSize(int sendBufferSize)` Sets the `StandardSocketOptions.SO_SNDBUF` option.
`void` `setSoLinger(int soLinger)` Sets the `StandardSocketOptions.SO_LINGER` option.
`void` `setTcpNoDelay(boolean tcpNoDelay)` Sets the `StandardSocketOptions.TCP_NODELAY` option.
`void` `setTrafficClass(int trafficClass)` Sets the `StandardSocketOptions.IP_TOS` option.

### Methods inherited from interface org.jboss.netty.channel.ChannelConfig

`getBufferFactory, getConnectTimeoutMillis, getPipelineFactory, setBufferFactory, setConnectTimeoutMillis, setOption, setOptions, setPipelineFactory`

### Method Detail

#### isTcpNoDelay

    boolean isTcpNoDelay()

Gets the `StandardSocketOptions.TCP_NODELAY` option.

#### setTcpNoDelay

    void setTcpNoDelay(boolean tcpNoDelay)

Sets the `StandardSocketOptions.TCP_NODELAY` option.

#### getSoLinger

    int getSoLinger()

Gets the `StandardSocketOptions.SO_LINGER` option.

#### setSoLinger

    void setSoLinger(int soLinger)

Sets the `StandardSocketOptions.SO_LINGER` option.

#### getSendBufferSize

    int getSendBufferSize()

Gets the `StandardSocketOptions.SO_SNDBUF` option.

#### setSendBufferSize

    void setSendBufferSize(int sendBufferSize)

Sets the `StandardSocketOptions.SO_SNDBUF` option.

#### getReceiveBufferSize

    int getReceiveBufferSize()

Gets the `StandardSocketOptions.SO_RCVBUF` option.

#### setReceiveBufferSize

    void setReceiveBufferSize(int receiveBufferSize)

Sets the `StandardSocketOptions.SO_RCVBUF` option.

#### isKeepAlive

    boolean isKeepAlive()

Gets the `StandardSocketOptions.SO_KEEPALIVE` option.

#### setKeepAlive

    void setKeepAlive(boolean keepAlive)

Sets the `StandardSocketOptions.SO_KEEPALIVE` option.

#### getTrafficClass

    int getTrafficClass()

Gets the `StandardSocketOptions.IP_TOS` option.

#### setTrafficClass

    void setTrafficClass(int trafficClass)

Sets the `StandardSocketOptions.IP_TOS` option.

#### isReuseAddress

    boolean isReuseAddress()

Gets the `StandardSocketOptions.SO_REUSEADDR` option.

#### setReuseAddress

    void setReuseAddress(boolean reuseAddress)

Sets the `StandardSocketOptions.SO_REUSEADDR` option.

#### setPerformancePreferences

    void setPerformancePreferences(int connectionTime,
                                 int latency,
                                 int bandwidth)

Sets the performance preferences as specified in `Socket.setPerformancePreferences(int, int, int)`.